//===============================================================================
// @ IvDeviceListener.h
// 
// Abstract base class for device objects
// ------------------------------------------------------------------------------
// Copyright (C) 2008  Elsevier, Inc.
//
// Usage notes
//===============================================================================

#ifndef __IvDeviceListener__h__
#define __IvDeviceListener__h__

//-------------------------------------------------------------------------------
//-- Dependencies ---------------------------------------------------------------
//-------------------------------------------------------------------------------

//-------------------------------------------------------------------------------
//-- Typedefs, Structs ----------------------------------------------------------
//-------------------------------------------------------------------------------

//-------------------------------------------------------------------------------
//-- Classes --------------------------------------------------------------------
//-------------------------------------------------------------------------------

class IvDeviceListener
{ 
public:
    IvDeviceListener() {}
    virtual ~IvDeviceListener() = 0;
    
    virtual void DeviceCreated() = 0;
    virtual void DeviceDestroyed() = 0;
    
    virtual void DeviceReset() = 0;
    virtual void DeviceLost() = 0;
}; 

//-------------------------------------------------------------------------------
//-- Inlines --------------------------------------------------------------------
//-------------------------------------------------------------------------------

//-------------------------------------------------------------------------------
//-- Externs --------------------------------------------------------------------
//-------------------------------------------------------------------------------

#endif