//===============================================================================
// @ IvNode.h
// 
// Scene graph object that supports multiple child objects
// ------------------------------------------------------------------------------
// Copyright (C) 2008 by Elsevier, Inc. All rights reserved.
//
//===============================================================================

#ifndef __IvNode__h__
#define __IvNode__h__

//-------------------------------------------------------------------------------
//-- Dependencies ---------------------------------------------------------------
//-------------------------------------------------------------------------------
#include "IvSpatial.h"
#include <IvWriter.h>

//-------------------------------------------------------------------------------
//-- Typedefs, Structs ----------------------------------------------------------
//-------------------------------------------------------------------------------

//-------------------------------------------------------------------------------
//-- Classes --------------------------------------------------------------------
//-------------------------------------------------------------------------------

class IvNode : public IvSpatial
{
public:
    // constructor/destructor
    IvNode(unsigned int numChildren);
    virtual ~IvNode();
    
    // text output (for debugging)
    friend IvWriter& operator<<( IvWriter& out, const IvNode& source );

    virtual void UpdateWorldTransform();
    virtual void Render();

    unsigned int GetNumChildren() const { return mNumChildren; }

    IvSpatial* GetChild(unsigned int index) { return mChildren[index]; }
    void SetChild(unsigned int index, IvSpatial* child);

protected:

    IvSpatial** mChildren;
    unsigned int mNumChildren;
};

//-------------------------------------------------------------------------------
//-- Inlines --------------------------------------------------------------------
//-------------------------------------------------------------------------------

//-------------------------------------------------------------------------------
//-- Externs --------------------------------------------------------------------
//-------------------------------------------------------------------------------

#endif
